\documentclass[twoside, 11pt]{article}
\usepackage{jair, theapa, rawfonts}
%\usepackage{cite}
\usepackage{amsmath,amssymb,amsfonts}
%\usepackage{algorithmicx}
%\usepackage{algpseudocode}
\usepackage{graphicx}
%\usepackage{textcomp}
\usepackage[dvipsnames]{xcolor}
%\usepackage[normalem]{ulem}
%\usepackage{enumitem}
%\usepackage{fancyvrb}
\usepackage{url}
%\usepackage{hyperref}
\newcommand{\href}[2]{#2\footnote{\url{#1}}}
%\usepackage{booktabs}
%\usepackage{multirow}
%\usepackage{lscape}
\usepackage{listings}
%\usepackage{rotating}
%\usepackage{titlesec}
\usepackage[normalem]{ulem}
\usepackage[T1]{fontenc}
\interfootnotelinepenalty=100000

\newcommand{\deq}{\stackrel {\rm def}{=}} 
\newcommand{\eqline}[1]{~\vspace{0.3cm}\\\centerline{$#1$}\vspace{0.3cm}\\}
\newcommand{\tab}{\hphantom{6mm}}

\newcommand{\vthierry}[1]{{\color{magenta} @vthierry:[#1]}}
\newcommand{\chloe}[1]{{\color{blue} @chloe:[#1]}}
\newcommand{\louis}[1]{{\color{red} @louis:[#1]}}
\newcommand{\axel}[1]{{\color{green} @axel:[#1]}}

%\jairheading{0}{2023}{}{}
\ShortHeadings{Metrizable symbolic data structure for ill-defined problem solving}{Palaude, Mercier, K\"ohler, Vi\'eville}
%\firstpageno{0}

\begin{document}

\title{Metrizable symbolic data structure \\ for ill-defined problem solving}

\author{
       \name Axel Palaude \email axel.palaude@inria.fr \\
       \AND
       \name Chlo\'e Mercier \email chloe.mercier@inria.fr \\
       \AND
       \name Louis K\"ohler \email louis.kohler@etu.univ-cotedazur.fr \\
       \AND
       \name Thierry Vi\'eville \email thierry.vieville@inria.fr \\
       \addr Inria, Mnemosyne team, IMN,\\
       Neurocampus, 146 rue Léo Saignat, CS 61292 33076 Bordeaux cedex France}

% \researchnote

\maketitle

{\small \begin{flushright}Submitted to \href{https://www.jair.org/index.php/jair}{JAIR}\end{flushright}}

\begin{abstract}
  Within the context of cognitive computational neuroscience modeling, with both symbolic and numerical approaches, i.e., neurosymbolic artificial intelligence, we propose here an unusual way to relate explicit and readable data structure representing both the system state and its related meta-data with biologically plausible numeric operations: Very simply, we consider a parameterized edit distance between two hierarchical symbolic data instances, thus embed data in a metric space, in such a way that we can define the notion of geodesic between two data. We also define in this symbolic space the notion of data region (i.e., data type or concept) and the concept of projection onto such a region, so that very generic machine learning algorithms can now be applied at both the symbolic and numerical level simultaneously.

  On the one hand, we detail how such an approach can be applied to ill-defined open-ended problem solving expressed at the symbolic level, using a geometric formulation inspired by related work on creative problem-solving. On the other hand, we explicitize how usual reinforcement learning algorithms, considering Q-learning as a basic example, can now be generalized to a problem space of large dimension, beyond the usual enumerable state case.

  Perspectives of this alternative proposal include human problem solving, learning issues and explicable artificial behaviors, as discussed in the conclusion.

  This work could be interesting to other researchers in both computational neuroscience, for model simulation, and artificial intelligence, to design explainable explicit ill-defined problem-solving mechanisms, because it provides a rather straightforward data representation on which generic numerical algorithms of planning or learning could be directly applied, generating explicit symbolic plans and outcomes, providing that the data structure distances have been properly parameterized for a given application domain. 

\end{abstract} 

\section{Introduction and positioning} \label{introduction}

Within the context of cognitive computational neuroscience modeling, with both symbolic and numerical approaches, i.e., neurosymbolic artificial intelligence, we propose here an unusual way to relate explicit and readable data structure representing both the system state and its related meta-data with biologically plausible numeric operations.

To this end, we need to first position the proposed technical development with respect to brain modeling at a symbolic level, both in terms of paradigm, and in terms of knowledge representation, while also briefly reviewing existing approaches in order to position the originality of what is proposed here. This is going to be done in this section.

We must then define what we precisely mean by a ``symbolic'' approach for both the system state and its related meta-data, i.e., for both what is encoded in the neuronal ensembles and the modeling knowledge allowing us to explain and interpret it. To this end, in the next section, we revisit first what are signs and symbols, discussing the underlying concepts, and allowing us to share our design choices.

Based on this, the third section describes at the computational level, how the previous abstract data structure ingredients can be formalized, including at the programming level, allowing to consider generic numeric algorithms directly on the symbolic data structures and making explicit the formal requirements of distance and of a notion of region, equipped with a projector of a data point onto such a region.

The development related to the creation of a metrizable symbolic data structure embedded in a metric space, requires also the specification of a scalar field, using the notion of geodesic between two data and the notion of data region (i.e., data type or concept), which is postponed to the fourth section.

The final section discusses how rather generic machine learning algorithms can now be applied at both the symbolic and numerical level simultaneously to encounter for generic mechanism of open-ended or ill-defined complex problem solving, and reinforcement symbolic learning, before a short conclusion.

\vspace*{-0.05in} \subsection{Brain modeling at a symbolic level} \vspace*{-0.05in} \label{brain-symbolic}

Studying the brain is performed at different temporal and spatial scales, and also at different topological network scales, as illustrated in Fig.~\ref{neuroscales} from \cite{betzel_multi-scale_2016}. Their review shows that multi-scale topological structure modeling requires a qualitative symbolic description of e.g., the clusters or attractors, or what they called the ``communities'' hierarchy, in addition to qualitative properties (in the dynamic system theory sense). This means that the description requires a non-trivial symbolic data structure, and not only a numerical representation of the behavior. This is one aspect of the proposed work.

\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.7\textwidth]{./neuroscales.png}
  \end{center} \caption{Brain networks are organized across multiple spatiotemporal scales, and also at different topological network scales, from \cite{betzel_multi-scale_2016}, see text.}
\label{neuroscales}
\end{figure}

\vspace*{-0.05in} \subsubsection{From numeric to symbolic brain modeling} \vspace*{-0.05in} \label{modeling-scale}

There is another aspect of numerical versus symbolic modeling of the brain, considering a fourth, say, ``modeling'' scale, in the sense of Marr, as reviewed and questioned in \cite{hardcastle_marrs_2015}. The original Marr or Gibson frameworks (see \cite{glennerster_computational_2002} for a comprehensive review) were very fruitful, showing that cognitive processing, e.g., vision passes through a series of stages, each corresponding to a different representation, from neural input activity (e.g., a retinal image), to high-level symbolic representation (e.g., a 3D representation of a scene as objects). A key point of both theories was that contingent regularities in the physical environment, known by the system, explain how the visual system determines the shape and location of objects in the world on the basis of the retinal input. This generalizes to other sensorimotor skills. Such knowledge is to be represented as symbolic information. However, as pointed out in \cite{hardcastle_marrs_2015}, the notion of the computational stage has highly evolved with the progress in computational neuroscience. More than a final stage, the computational paradigm is at the core of the interaction between the so-called implementation and a more high-level behavioral stage, i.e., in link with a modeling scale (e.g., \cite{kitcher_marrs_1988}). This is sketched out in Fig.\ref{neuroparadigms}. At the difference of Marr's original three implementation, algorithmic and computational levels, we consider the implementation level, more precisely, as a biophysical representation in the wide sense, and consider as the highest level the cognitive behavior, while the computational stage, includes algorithmic aspects. This also allows us to clarify that the numerical, i.e., quantitative, aspects mainly stand on the biophysical side, while symbolic representation mainly stands on the behavioral stage, of course not exclusively, but more than a gradient. The key point is that computational representation must intrinsically be able to manage both representations conjointly. This corresponds to the development proposed here.
 
\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.8\textwidth]{./neuroparadigms.png}
  \end{center} \caption{A tentative to revisit the original Marr's cognitive stages, considering the recent computational neuroscience progress, allowing to clarify the numeric to symbolic gradient in both internal knowledge representation and related modeling, as discussed in the text: The top line reproduces the Marr's three levels, while the cognitive level is added because missing in the original description. Taking more recent studies into account, a different organization of this modeling dimension of brain description is sketched out in the lower part of the figure.}
\label{neuroparadigms}
\end{figure}

\vspace*{-0.05in} \subsubsection{From phenomenological to ontological brain modeling} \vspace*{-0.05in} \label{ontology-modeling}

Usually, the symbolic aspects of brain activity modeling are discussed at a phenomenological level, i.e., in a human-readable form, and the formalization is represented through block diagrams, showing the relations between model entities, each entity (e.g., a sensorimotor mechanism or a cognitive function) being defined via a key-word, a human-readable comment,  properties and relations with other entities. This is more or less an informal ontology (see \cite{cao_web_2014} for a general introduction and \cite{noy_ontology_2001} for a practical approach). A step further, the brain is modeled using such a well-established framework, as explained in \cite{gleeson_open_2019}, and made available on the \href{https://www.opensourcebrain.org}{Open Source Brain (OPS)} platform that gathers many projects together. The brain anatomy is already formalized from a rather long time, as, for instance, a \href{https://www.dbpedia.org}{DBpedia} resource (see \cite{dojchinovski_dbpedia_2021} for a presentation of this crowd-sourced community effort of extraction of structured information from various Wikimedia projects), while the OPS platform provides knowledge representation of microscopic (e.g., the Hodgkin-Huxley model) or mesoscopic (e.g., the neocortex cortical columns) models, while macroscopic cognitive models corresponds to work in progress: problem-solving tasks has been addressed \cite{carbonell_using_1997} focusing recently in computational thinking \cite{mercier_formalizing_2021} when engaged in a creative open problem-solving activity \cite{mercier_ontology_2022}; more generally  formalization of learning has been reviewed in \cite{stancin_ontologies_2020}, (e.g., in game based learning resources \cite{abou_elfotouh_serious_2017}), targeting adaptive learning \cite{cheung_ontology-based_2010}, in e-learning systems (see \cite{george_review_2019} for a review), including modeling the learner (see \cite{abyaa_learner_2019} for a review), and also to better formalized mental diseases \cite{hastings_representing_2012}. However, these are external descriptions of the brain and it would be interesting to also introduce such symbolic data representation in models simulating the brain behavior itself, as discussed now. 

\vspace*{-0.05in} \subsection{Neurosymbolic approaches} \label{neurosymbolic}

Numeric machine learning mechanisms, i.e. calculating, is mainly based on statistical inferences, including Bayesian inference, and has now reached outstanding performances. On the other hand, when manipulating knowledge, explicit symbolic machine learning mechanism, i.e. reasoning, is much more efficient to infer knowledge from known facts, and hybrid mechanisms seem mandatory for complex tasks where non-trivial a priori knowledge is to be introduced (see, e.g, \cite{de_penning_neural-symbolic_2011} for a realistic application). It has also great advantages when both interpretability (by an expert) and explainability (for end users) is a key feature, as discussed in \cite{chraibi_kaadoud_explaining_2022} in link with creativity, These features are essential if such learning mechanisms are used to model cognitive functions. In addition, formal reasoning is by no means less costly than billions of operations of deep networks computation, as studied by \cite{desislavov_compute_2023}, which limit their academic use for usual research teams, beyond raised ecologic and ethical issues, discussed by the authors. The use of such ``black-box'' tools at the modeling level is also questionable as analyzed in \cite{schaeffer_no_2022}.

Coupling both approaches should bring the required computational power to solve complex problems or model complex brain functions, in an explainable way, and with parsimonious resources consumption, and neural-symbolic computing brings together robust learning in neural networks with reasoning and explainability via symbolic representations as recently reviewed in details in \cite{garcez_neurosymbolic_2023}. It is an active area of research for many years and the author's detailed analysis considers different coupling levels:
\\ -  Type 1: {\em standard numeric computation with symbolic input/output} (e.g., word2vec nicely introduced in \cite{rong_word2vec_2016}). In this class of method, symbolic input is embedded in a numerical space that is able to encounter the pertinent relation between the input symbols\footnote{More precisely, for word2vec, text words are considered within a small segment of text, embedded in a huge trivial dimensional space (one dimension by input) to be reduced by cross-entropy between input and output distribution optimization to a hidden encoding layer regenerating the output as in usual auto-encoder architecture}. The symbolic processing is devoted to, e.g., a deep neural network in which output units feed a softmax (sometimes hierarchical) mechanism attributing a kind of probability to each expected symbol.
\\ - Type 2,3: {\em hybrid systems with symbolic and numeric modules interaction} (e.g., the well-known DeepMind's, AlphaGo or ChatPGT) corresponds to loosely-coupled neural network with a symbolic problem solver up to more sophisticated interactions between both systems.
\\ - Type 4,5: {\em symbolic knowledge and rules are compiled in distributed calculation} (e.g. Vector Symbolic Architectures (VSA) \cite{eliasmith_how_2013}) either using localist mapping of symbols or more complex embedding of symbolic rules, in both cases symbolic knowledge is translated into the network architecture and parameters. Relevant examples stand from localist logical neural networks \cite{riegel_logical_2020} to logic tensor network \cite{serafini_logic_2016}.
\\ In addition a type 6 is evoked as a perspective on ongoing research\footnote{This layer is described as able to solve high cognitive functions, like attention schema, with the hope of being able to perform efficient combinatory reasoning (i.e., find approximate solutions to NP-hard problems by hybrid, de facto polynomial systems). This last point corresponds to existing algorithms as for instance reviewed in \cite{paschos_overview_2007}.}. The present work precisely aims at considering type 4 or 5 coupling levels.

One motivation for such an approach is explainability, as reviewed by \cite{burkart_survey_2021} in the domain of supervised learning, with both the capability to interpret both results and reasoning path, but also, as mentioned by the authors, to be able to introduce high-level explicit a-priory knowledge which allows to better constraint the system, thus provide more efficient results. This may be another interest of the present approach. Being able to work at both the numeric and symbolic level is well illustrated, in link with focusing on problem-solving as done here, by \cite{vasileiou_logic-based_2022} discussing a logic based explanation mechanism in planning, dedicated to controlled hybrid systems in human interaction. This efficient approach of the authors specify the symbolic layer ``outside'' the related numeric representation, while at a more basic but better integrated level, such plan is represented by the notion of abstract path, as developed in this paper. Link between symbolic and numeric approaches when considering domain-independent planners is also well illustrated in \cite{asai_classical_2022} and we wonder if our data representation could not be an interesting tool, for such an architecture. This work is also in link with ontology related reasoning as, for instance in \cite{hohenecker_ontology_2020} for which the symbols are optimally encoded in the network numeric variables. Here as a dual approach, numeric elements cover symbolic data in our case. The link between our representation and ontology approaches is also detailed here. 

Further technical elements about symbolic versus numeric representation are discussed in Appendix~\ref{symbonumerication}.

\vspace*{-0.05in} \subsubsection{Neuro-symbolic brain modeling} \vspace*{-0.05in} \label{neurosymbolic-modeling}

A key point is that, up to our best knowledge, computational neuroscience models are mainly based on either Type 1 mechanisms, like encoders, with the epistemological issues at the modeling level, evoked before, and quite exceptionally Type 2,3 (e.g., \cite{spens_generative_2023} that study to what the GPT model used in ChatGPT can encounter for hippocampus replay training neocortical generative models, although it is not clear about is learned by such a general-purpose model regarding the hippocampus specificity, while such approach is far from being refutable\footnote{We make here a distinction between the historic notion of falsifiability and refutability, see \cite{olszewski_falsifiability_2011} and \cite{cartwright_how_1983} for a wider epistemological discussion on modeling.}), while the Type 5 VSA architecture (after \cite{eliasmith_how_2013}) based on Semantic Pointer Architecture (SPA) introduces an intermediate algebraic abstract view of spiking neural network architectures, in order to develop biologically plausible cognitive functionalities, and human knowledge representations \cite{crawford_biologically_2016}, including high-level symbolic representation allowing reasoning \cite{mercier_ontology_2021}, including regarding not only deductive but also inductive and abducting reasoning, as discussed in \cite{mercier_where_2023}.

As a complementary approach, to the previous works, we are not going to study how to embed a symbolic representation onto a given numeric space, but how to equip directly the symbolic data structure with the numeric ingredients needed to apply numeric algorithms, and show how general algorithms can be applied directly on the symbolic data structure by this mean. To this end, in the next section let us precisely state what is a ``symbolic representation'', in order to make explicit our design choices to represent cognitive symbolic information.

\paragraph{On slow versus fast thinking}~\\

A step further, considering information processing, this distinction between numerical and symbolic information is associated to the notion of fast and slow thinking popularized by \cite{kahneman_thinking_2011} and revisited in the double perspective of human and machine computation \cite{bonnefon_machine_2020} and cognitive functions \cite{shleifer_psychologists_2012}. In a nutshell, "fast" thinking corresponds to numerical calculation, e.g. deep-learning, at the cognitive level it operates automatically, intuitively, involuntarily, and effortlessly. This involves our procedural memory for habitual behavior (e.g., driving a car) or memory recall (either episodic or semantic), or basic perceptual tasks (e.g., recognizing an object). This computational mode can be interpreted at a symbolic level (e.g., associating symbols to state configurations), but seems to be mainly numeric. On the other hand, "slow" thinking is associated with symbolic reasoning, e.g, a first-order logic reasoner, and corresponds to cognitive processes that require slowing down, deliberating, solving problems, reasoning, computing, focusing, concentrating, considering other data, and so on. It is mainly associated to symbolic information, although, in our brain, it is also implemented at the neuronal coding and processing level, which modeling is nowadays involving numerical calculi, but with the key idea that it is understandable and interpretable only at a more symbolic level, beyond molecular chemical reactions, or neuronal network dynamic. This dual presentation has been discussed in more detail in \cite{romero_deciphering_2023} with the interesting conclusion that modeling fast thinking also requires symbolic information. Our proposal thus applies to both aspects of a cognitive system.

\section{Symbolic data representation} \label{representation-data}

\begin{flushright} ``In the beginning was the Symbol, and the Symbol was \\ with the Universe, and the Symbol was the Universe.''
\\ {\small From\footnote{The original citation uses ``Word'' for ``Symbol'' and ``God'' for ``the Universe'', daring here, with total respect, to propose an agnostic version of it.} Gospel, John 1:1}\end{flushright}

\vspace*{-0.05in} \subsection{Symbolic data representation using signs} \label{data} \vspace*{-0.05in}

What is a symbol? Apparently obvious, this notion is the ground of our human knowledge, and when daring to consider ``symbolic representation'', we need to clarify in detail what is defined here. At first glance, at the syntactic level, a symbol is an ``atom of knowledge'', and is no more than the label (or identifier) of an object in the wide sense. It has a ``meaning'' in the sense of \cite{harnad_symbol_1990}, as reviewed and discussed in \cite{taddeo_solving_2005}, when it is semantically {\em grounded}, in the sense of the \href{https://en.wikipedia.org/wiki/Symbol_grounding_problem}{``symbol grounding problem''}, understood as the process of embedding symbolic computations onto real-valued features \cite{badreddine_logic_2021}, thus providing a semantic interpretation or model (in the sense of a model of a set of logical assertions) of the symbolic system, which involves the capacity to pick referents of concepts and also a notion of consciousness. This includes \href{https://en.wikipedia.org/wiki/Affordance}{affordance}, i.e., not only features but also the capability of interaction with it, to attain an objective, and receive some outcome. This means that it is no longer an abstract set of assessments (potentially without any concrete implementation) but something that corresponds to a real object. A step further, this notion of grounding is also polysemous and is also used for numerical grounded, say anchoring, as sketched out in Fig.\ref{symbolaslabel} and discussed in \cite{mercier_where_2023}, considering Vector Symbolic Architecture (VSA) of high-dimensional ($>$ 100) random bounded unary vectors accounting for spiking network state, as proposed by \cite{crawford_biologically_2016}.

\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.8\textwidth]{./symbolaslabel.png}
  \end{center} \caption{Symbol and grounding: At first glance, a symbol is no more than the label of something, and in the literature it is semantically grounded to a real concrete or abstract object if, anchored in sensorimotor features, it has a meaning, as defined in the text. At the biologically plausible level, it also can be numerically grounded, or anchored, to a numerical representation, accounting for a given neurological ensemble activity.}
\label{symbolaslabel}
\end{figure}

As discussed in, e.g., \cite{raczaszek-leonardi_ungrounding_2018}, in relation to the emergence of symbolic thinking (see, e.g., \cite{villiers_why_2007} for a detailed discussion), the key problem is ``ungrounding'', i.e., how a symbolic representation can emerge from sensorimotor features and interaction with the environment. In \cite{rougier_implicit_2009}, considering the issue at the computational neuroscience level, it is discussed that to address such an issue, one must avoid explicitly embedding any symbol anywhere in the model, a priori or a posteriorly, but consider only emergence.

This aspect of the emergence of symbols, i.e., the fact that a symbolic representation emerges from a biological or any physical system in interaction with its environment, is enlightened by the semiotic approach as reviewed in \cite{villiers_why_2007}, first considering a wider notion of ``sign'' and introducing a hierarchical meaning of an ``icon'' built only from sensorimotor features, i.e. at the level of the likeness with the object, e.g., with features such as color or smell, structures at an ``index'' level built by concrete relationships between given objects, i.e., at the level of a relation with the object, e.g., a weathercock indexing the wind direction and strength, this giving rise to a ``symbol'' in the semiotic sense, which corresponds to abstract general relationships between concrete concepts or sensorimotor features, but with a qualitative break-up with respect to concrete object features, e.g., a road sign, as schematized in Fig.~\ref{signsandsymbols}.

\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.8\textwidth]{./signsandsymbols.png}
  \end{center} \caption{The semiology hierarchy of sign and symbols, see text for details.}
\label{signsandsymbols}
\end{figure}

Such hierarchy is very interesting because in direct link with cognitive architectures, as proposed for instance by \cite{olteteanu_cognition_2020}, see Fig.~\ref{olteteanu}, showing its pertinence for creative problem solving, as addressed in this study. In this framework, concepts are anchored on sensorimotor features and can be learned in a top-down way, observing a new element as belonging to a concept already known, or in a bottom-up way emergence through the identification of patterns. 
Problem templates are structured representations based on tuples of concepts, with relations between concepts, and include heuristics represented by sets of moves and solution state representations. Creative mechanisms are based on either concept or problem template similarity, i.e., considering a distance or weak notion of distance between them, allowing the system to either consider or use a given concept or problem template in another context or merge them to create a new one. These are exactly the tools proposed with the formalism introduced here.

\begin{figure}[htbp] \begin{center}
    \includegraphics[width=0.7\textwidth]{./olteteanu.png}
  \end{center} \caption{The \cite{olteteanu_cognition_2020} symbolic architecture, with an ``icon'' layer anchored in sensorimotor features, allowing the emergence of [concrete] concepts, indexing the sensorimotor features, used at more abstract to specify problem templates as structure over concepts, leading to creative problem-solving mechanism.}
\label{olteteanu}
\end{figure}

\vspace*{-0.05in} \subsection{Symbolic data representation with respect to language} \label{data-language} \vspace*{-0.05in}

A step further, regarding symbol, we would like to briefly review two dualities.

\vspace*{-0.05in} \subsubsection{Syntax versus semantic} \vspace*{-0.05in} 

On the one hand, the notion of syntax versus semantic, as summarized in Fig.~\ref{syntaxversussemantic}, this with the goal to avoid terminology ambiguity, while the semantic cognition domain is considered here: We would like to propose a mechanism to model semantic concepts built on to sensorimotor features. In the brain, at the language level, as clearly shown by \cite{caucheteux_disentangling_2021} or discussed in \cite{tozzi_syntax_2018}, contrary to previous claims, syntax, and semantics are not associated with separated modules, but, instead, appear to share a common and distributed neural substrate. At the cognitive level, regarding sensorimotor tasks, this dual notion of syntax versus semantic is mainly attributed to sensorimotor rules for the former, and sensorimotor meaning, i.e., grounding for the latter, as discussed in, e.g., \cite{alexandre_creativity_2020}, as schematized in Fig.~\ref{syntaxversussemantic}.

\begin{figure}[htbp] \begin{center} {\scriptsize \begin{tabular}{|l|l|l|}
      \hline
      {\bf Domain} & {\bf Syntax} & {\bf Semantic} \\
      \hline
      {\em Logic} &
       \parbox[u]{0.4\textwidth}{
       The rules for constructing and transforming the symbols} &
       \parbox[u]{0.4\textwidth}{~\\
       Model semantic: building a mathematical model satisfying the rules; \\
       Proof semantic: w.r.t. the roles that they can play in inferences (i.e., ``utility´´); \\
       Truth semantic: expansion over individuals of formulas. \\ } \\
      \hline
       {\em Computing} & 
       \parbox[u]{0.4\textwidth}{
       The rules for expressing algorithms through data and operational symbols} &
       \parbox[u]{0.4\textwidth}{~\\
       The processes a computer follows when executing a program; \\
       The process properties, including decidability, time/space complexity; \\
       The mechanism to formalize human interpretable meaning attributed to symbols.\\} \\
      \hline
       {\em Cognition} & 
       \parbox[u]{0.4\textwidth}{
       Formal meaning by (quantitative or qualitative) relations with another symbol, building a formal model} &
       \parbox[u]{0.4\textwidth}{~\\
       Operational meaning by sensorimotor interaction, in link with experience, including, overt or covert affordance (i.e., perceived action or consequences (gist)).\\} \\
       \hline
  \end{tabular}}\end{center} \caption{The syntax versus semantic duality: A polysemous notion depending on the domain. Here the cognition domain is considered and semantic aspects are discussed. See \cite{laird_standard_2017} for a presentation of syntax versus semantic notions in cognition, and \cite{hou_fundamentals_2021} for an introduction regarding the other items.}
\label{syntaxversussemantic}
\end{figure}

\vspace*{-0.05in} \subsubsection{Human versus formal language and cognition} \vspace*{-0.05in} 

On the other hand, we also would like to link our positioning with respect to the distinction between the human language (``langue'' in French) and formal language (``langage'' in French) as discussed by \cite{dowek_langues_2019}, and reviewed in Fig.~\ref{dowek-language}, for the main features. Beyond, a key aspect is that human language is mainly mono-dimensional (i.e., a sequence of words) while symbolic representations (e.g., as maps) can have several dimensions, so are brain representations \cite{eichenbaum_memory_2017}. For these reasons, it seems reasonable to conjecture that symbolic representation in the brain is neither a formal language (as, e.g., a computer language or a formal procedure), nor a human verbal or written language, but the ``ungrounding'' (as reviewed previously) of sensorimotor features and relations between features at a double level of abstraction, as schematized in Fig.~\ref{signsandsymbols} or proposed in cognitive architectures such as shown in Fig.~\ref{olteteanu}. The fact symbolic representation does not require human language is obvious when observing (see, e.g., \cite{sinclair_transition_1970} for clarification between the sensorimotor stage and early non-verbal symbolic task solving). We synthesize these elements in Fig.~\ref{dowek-language}.

\begin{figure}[htbp] \begin{center} {\scriptsize \begin{tabular}{|l|l|l|}
      \hline
      {\bf Symbol in formal language} & {\bf Symbol in human language} & {\bf Cognitive symbol} \\
      \hline
      \multicolumn{3}{|l|}{\parbox[u]{0.9\textwidth}{
          Discrete representation (as opposed to continue representation). \\
          Mainly arbitrary symbols (at the difference of semiotic-defined icons or indexes). \\
          Independent of their function (separation between hardware and encoded software). \\
          Independent of materialization and energy.}} \\
      \hline
      \parbox[u]{0.3\textwidth}{
        Simple grammar (i.e., syntax) and vocabulary. \\
        Semantic field specialization. \\
        No grounding. \\
        Intentional and incremental (using variables and new constants). \\
        The main usage is information processing.
      } &
      \parbox[u]{0.3\textwidth}{
        Complex grammar with rules and exceptions. \\
        Universal semantic field. \\
        Grounded semantic (evolve along usage). \\
        Almost only predefined ``words'' (except neologism). \\
        The main usage is communication.
      } &
      \parbox[u]{0.3\textwidth}{~\\
        No notion of grammar, or syntax corresponds to encoding. \\
        The symbol semantic is adapted along interactions. \\
        Symbols are grounded in sensorimotor interactions.\\
        Symbols are incremental (creation, merge, bifurcation). \\
        The main usage is sensorimotor tasks (e.g., survival).\\
      } \\
      \hline
  \end{tabular}}\end{center} \caption{The notion of symbol in formal versus human language and as a cognitive symbol. The 1st and 2nd columns are borrowed from \cite{dowek_langues_2019}, and the third summarizes the present discussion. Formal language refers to an information coding system, such as a music core before human interpretation, whereas human language refers to a natural language we speak, such as the musical interpretation of a music core by a human. Cognitive symbols are neither in one-to-one correspondence with human natural language nor formalized symbols, as discussed here.}
\label{dowek-language}
\end{figure}

\vspace*{-0.05in} \subsection{A ``natural'' usual way to represent and structure data} \vspace*{-0.05in} \label{semantic-data-structure}

Let us now present our design choices.

At the computing level, we aim at manipulating the symbolic representation of knowledge of the form shown in Fig.~\ref{concept-grounding}, as introduced in \cite{mercier_where_2023}. In our context, we represent concepts as a hierarchical data structure. Concepts are anchored in an  input/output, i.e., stimulus/response, framework, which might consist of sensorimotor feature spaces (colored regions) corresponding, for example, to different sensor modalities. Inherited features (e.g., the penguin “is-a” bird and thus inherits the features of a bird) are shown with dotted lines, while red lines represent overwritten values (e.g., a penguin can also swim but cannot fly). Green arrows point toward concepts that are themselves attributes of other concept features, accounting for inter-concept relationships.
Values are completed by meta-information that is not explicitly manipulated by the agent but is used for process specification or interpretation (e.g., the weight unit and bounds).

\begin{figure}[htbp]
\centerline{\includegraphics[width=\textwidth,height=0.5\textheight]{concept-grounding.png}}
\caption{Hierarchical data structure representing concepts, see text. From \cite{mercier_where_2023}.}\label{concept-grounding}
\end{figure}

At the modeling level, we follow \cite{gardenfors_conceptual_2004}, with the simple idea that an individual resource can be defined by ``feature dimensions,'' i.e., attributes with some typed value. For instance, a bird could be the following. The used syntax is a \href{https://line.gitlabpages.inria.fr/aide-group/wjson}{weak form of the JSON syntax}.

\begin{lstlisting}[basicstyle=\small]
bird: {
  is_a: vertebrate
  can: { sing fly eat: { worm fish } }
  has: { feather beak }
  is: { weight: { min: 0.010 max: 50 unit: kilogram } }
},\end{lstlisting}
with some exceptions like penguins:
\begin{lstlisting}[basicstyle=\small]
penguin: {
  is_a: bird
  can: { fly: false walk }
}.
\end{lstlisting}

Here, we choose the general approach of semantic knowledge representation using a hierarchical taxonomy ({\tt is-a}) with capability features ({\tt can}), including those related to other resources, extrinsic features ({\tt has}), and intrinsic features ({\tt is}) \cite{mcclelland_parallel_2003}.
This illustrative example is sufficient to allow us to detail the main characteristics of our representation.
Some features are properties, and others are relations. A property can be qualitative, e.g., the {\tt is-covered-by} property takes a value in an enumeration (e.g., \{{\tt sing}, {\tt fly}\}), or quantitative (e.g., the {\tt weight}). The features can be hierarchical, either because the value is an enumeration (e.g., {\tt can}) or because the value has some features (e.g., {\tt weight}).

Such a data structure defines a ``concept'' in the sense of \cite{gardenfors_conceptual_2004} (e.g., ``a bird''), which is both a convex region of the state space (e.g., the region of all birds) and a prototype: Each feature has a default value, and this also defines a prototype (e.g., a typical, i.e., prototypical, bird). It corresponds to the third cognitive memory architecture, as proposed by \cite{eichenbaum_memory_2017}. At the programming level, it is going to be implemented as a ``type''. At the geometric level, data value corresponds to points and concept to regions, but with tricky property: Any data structure is the prototype of a region, as detailed in the next section.

When defining such data structure, there are obviously several design choices and the following general recommendation might be useful:
\\- {\em Atomic value}: It is always better to decompose the information as much as possible in atomic irreducible elements (e.g., <tt>family\_name: Smith first\_names: [John Adam]</tt> instead of <tt>name: 'Smith, John Adam'</tt>) for algorithmic processing.
\\- {\em Maximal tree structure}: It is always better to organize features in sub-structures than to present flattened information (e.g., create a sub-structure for the name, birth date, etc…) in order to maximize modularity.
\\ We already mentioned the importance of providing as much as a possible default value, and this is a design requirement at several levels, see for instance Appendix~\ref{numeric-type} for a discussion at the numeric data representation level.
\\ We also point out, at the very concrete implementation level, that it is always preferable to choose explicit and standard names for features, i.e., look at already established vocabulary, otherwise avoid acronym or abbreviation, i.e., choose the most common word for the feature to name.

Using Vector Symbolic Architecture implemented at the neural spiking assembly level thanks to the Neural Engineering Framework \cite{eliasmith_how_2013}, such a cognitive symbolic data structure can be implemented as biologically plausible memory, allowing to manipulate it conjointly at both a symbolic and numeric level \cite{mercier_where_2023}.

\section{Symbolic data specification} \label{specification-data}

\vspace*{-0.05in} \subsection{Solving problem as a trajectory generation problem} \label{problem-solving-as-trajectory}

We consider manipulating symbolic data structure within usual machine learning algorithms, for instance, considering a reactive system engaged in some open-ended ill-defined problem-solving task. We define problem-solving tasks at a geometric level, considering being located somewhere in a state-space, with the goal of reaching some final (unique or not, possibly partially defined) state, finding a way from the former to the latter, while satisfying the path constraints. Here the goal has to be specified as part of the task, and the state space is to be explored and discovered, as illustrated in Fig.~\ref{problem-solving-as-trajectory}.

\begin{figure}[htb]
\centerline{\includegraphics[width=0.9\textwidth]{./problem-solving-as-trajectory.png}}
\caption{Formalizing Problem Solving as a Trajectory Generation Problem in an Abstract State Space.
Given, for instance, for the \#CreaCube robotic open-ended problem-solving task \cite{romero_creacube_2019}, the initial state corresponds to the initial setup, path states to exploration or partial construction of the solution, path constraint to inappropriate configuration (here the cube tower falls down) and goal state to some (not unique) solution, while several paths are possible regarding such an open problem. Since the problem is ill-defined, the state space is not known from the beginning but is discovered when solving it. Each point in this abstract state space is not numeric but corresponds to a symbolic description of the scene, as developed in the text. This can be linked to a notion of reward, written $V$ on the figure, and discussed in the text.} \label{fig:problem-solving-as-trajectory}
\end{figure}

The pivotal idea of this geometric definition is to consider an abstract state space where each point is a symbolic data structure, representing contextual information about the physical space and about the agent's internal state. Selecting a local trajectory corresponds to deciding, as a step in the problem-solving process, to modify some characteristics of the state space both at the external level (e.g., moving an object) and at the internal level (i.e., modifying the internal representation).

This includes contextual information about the physical space but also about the agent, including the internal (e.g., emotional) state of it, or of a model of her or him. Generating a trajectory corresponds to deciding, as a step in the problem-solving process, to modify some characteristics of the state space both at the physical level (e.g., moving an object) and at the psychological level (i.e., modifying some internal value of the learner).

As it, starting with \cite{newell_knowledge_1981}, a general problem solver can be stated in the form of a trajectory generator, including at a biologically plausible algorithmic level \cite{vieville_improved_2002}\footnote{In \cite{vieville_improved_2002}, the state space is a finite-dimensional space (where dimensions can be added), in which elements (such as constraints and goal) are specified by implicit equations, which is a general and weakly constrained way of defining state-space regions, while the state-space parameterization is approximated during the trajectory generation by an iterative sampling (based on a kernel-based approach) along the trajectory, using harmonic control as a limit case of optimal control \cite{boumaza_optimal_2007}.}, including hierarchic in terms of scale and precision as developed by \cite{pizlo_human_2006}. Such representation allows to represent a conceptual space in the sense of \cite{gardenfors_conceptual_2004}, as developed here.

Such a specification can be extended to complex ill-defined problem-solving (see \cite{alexandre_modeling_2023} for an extended discussion). A complex problem is solved in several steps by generating sub-goals on the trajectory, which can easily be specified here. The open-ended goal is not well defined but simply constrained by certain requirements, making the final state not unique but corresponding to a region. Such a goal and obstacles are not known from the beginning while discovered during exploration, while the initial state is only partially known (and observable) to the learner, and there is no explicit operation to move from one state to another, but potential actions are discovered by the learner when interacting with the environment.

The key point is that such a formalism yields to a universal algorithm to solve a problem formalized that way, considering a reward null at the initial state, unbounded and negative of obstacles and unbounded and positive when a goal is reached, i.e., scalar-field, written:
\eqline{V({\bf x}) \deq \sum_i V_i({\bf x}) - \sum_j V_j({\bf x}), V_i({\bf x}) \deq \frac{\omega({\bf x}_i)}{\delta({\bf x}, {\bf x}_i)}, \omega(\cdot) > 0.}
where ${\bf x}_i$ and ${\bf x}_j$ are points respectively sampled by projection on the goal regions and on the obstacles or constraints regions by the algorithm. Here, $\delta()$ is an editing distance as developed in this paper. Goals can be ``weighted'' by $\omega(\cdot)$, i.e., given with a certain reward value that corresponds to their importance. Similarly, obstacles can be weighted, i.e., given a certain repulsion value that corresponds to the importance to avoid them. We always can choose $\omega(\cdot) = 1$ as the default value, if there is no benefit to introducing a priori information at this stage.

Given this variational formulation, solving the problem reduces to the global maximization of this scalar field from the symbolic data structures to the reward values. It is obvious to verify that such a potential corresponds up to a constant to the reward represented in Fig.~\ref{fig:problem-solving-as-trajectory}, while it attains a maximum on a goal state, maximization avoiding obstacles. It also means that a gesture or a plan is within this framework encoded by the goal and constraints, as it is the case in the hippocampus for navigation or in arm gesture as nicely reviewed by \cite{hoge_nature_2020}, showing that such representation is biologically coherent.

What is less obvious but developed in Appendix~\ref{subharmonic-potential}, is that this potential can be defined without local maxima, and globally maximized even when locally maximized and sampled on continuous goal and obstacle regions. This generalizes to symbolic data structures the algorithm developed in \cite{vieville_improved_2002}. It is also shown that if the potential specification increases (up to a bound) with exploration (i.e., adding points but never deleting them) the maximization algorithm converges. It thus means that this geometric representation is ``operational'' in the sense that it yields to a general resolution algorithm.

As far as symbolic representation is concerned we need to define a pertinent application-dependent metric, i.e., a distance between two values. We also need to define a projector onto a region, since the distance from a point to a region corresponds to the distance to the point projection. This is going to be defined in the next section.

\paragraph{The link with reinforcement learning}~\\

A step further, as proposed in \cite{mercier_reinforcement_2021}, implementing reinforcement symbolic learning, i.e,  reinforcement learning mechanisms developed on complex symbolic data structure as proposed here. Considering the vanilla mechanism of \href{https://en.wikipedia.org/wiki/Q-learning}{Q-Learning}, we are again in the situation of specifying an adaptive scalar field:
\eqline{Q(s, a) \deq \mathbb{E}[R\mid s, a], \;\;\;\; R \deq \sum _{t=0}^{\infty }\gamma ^{t} \, r_{t}}
where $s$ input stands for the observable part of the state value, $a$ output stands for the subject action, $\mathbb{E}$ for the expectation, $R$ for the reward to maximize in average which is the weighted sum of each reward $r_t$ obtained at time $t$, which an exponential time decreasing factor.

Given this scalar field, the generic algorithm is to exploit this model-free representation of the problem and choose $a_t \deq \mbox{arg max}_a Q(s_t, a)$ or to explore the effect of alternative actions $a_t$ using some suitable random draw.

The main point is that we are able to implement such reinforcement learning algorithms on complex symbolic data structures, beyond the very strong assumption of restraining to state spaces and actions spaces where all possible values must be enumerated in a tractable way, as required by Markov approaches. It also avoids considering the functional approximation of this Q-function using huge and rather opaque deep learning networks (see \cite{li_deep_2018} for a review and discussion). 
Although more sophisticated reinforcement learning algorithms do exist (see, e.g., \cite{gu_review_2023} for a recent review), this shows that reinforcement symbolic learning is feasible. Furthermore, considering the Q-learning mechanism is of interest to us, targeting cognitive modeling, because it is a basic ingredient of effective high-level cognitive functions such as the PROBE model and its extensions \cite{donoso_cerveau_2013,collins_reasoning_2012,domenech_executive_2015}.

Further developments are given in Appendix~\ref{qlearning}. At the implementation level, the key point is that interpolation between two given values is required as developed in section~\ref{scalarfield}.

\vspace*{-0.05in} \subsection{Structuring the state space with data type} \label{data-type}

Given the previous computational objective, the basic ingredient is to generate a metrizable symbolic data structure embedding (say, a ``symboling''). In the resulting metric space, the lever is the notion of editing distance, i.e., the fact that a symbolic data value is step by step edited in order to equal another value, as detailed in the next sub-section. Each elementary editing operation has an additive cost, yielding both a well-defined distance and geodesics, i.e. a minimal distance path from the initial value to the target value. The key point is that such distance depends on the data type\footnote{For instance, given a numeric value, it will depend on the chosen bounds, scale, and precision, as developed in Appendix~\ref{numeric-type}.}.

Moreover, given a data type, this specification includes the requirement of defining a projection of a data value in the neighborhood of the data type region onto it.

In order to precisely defined these operations at the programming level we introduce the notion of {\em type}.

On one hand, atomic types correspond to string, numeric, or modal (a generalization of Boolean) values, as in any usual language, but with enriched meta-values.

\begin{center} \begin{tabular}{|l|l|} \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/StringType.html}{string} & \parbox[u]{0.7\textwidth}{This data type specifies a subset of strings.} \\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/ModalType.html}{modal} & \parbox[u]{0.7\textwidth}{This \href{./modaltype.pdf}{data type} specifies a level of truth between -1 (false), 0 (unknown), and 1 (true), see Appendix~\ref{modal-type}.} \\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/NumericType.html}{numeric} & \parbox[u]{0.7\textwidth}{This data type specifies a numeric value with its related metadata (bounds, precision, unit, …), see Appendix~\ref{numeric-type}.} \\ \hline
\end{tabular} \end{center}

On the other hand, compound types correspond to usual enumeration, ordered list, unordered set, or named tuples, i.e., records. 

\begin{center} \begin{tabular}{|l|l|} \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/EnumType.html}{enum} & This data type specifies an enumeration of other values.\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/ListType.html}{list-of-*} & This data type specifies an ordered list of values.\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/SetType.html}{set-of-*} & This data type specifies an unordered set of values.\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/RecordType.html}{record} & This data type specifies a record of values, i.e., named tuples.\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/Type.html#}{value} & This data type is the root data type that corresponds to any value. \\ \hline
\end{tabular} \end{center}

Specification details and type parameterization is detailed in Appendix~\ref{data-implementation}.

The present preliminary implementation only considers the basic atomic type, but it would be very easy to include all usual \href{https://www.w3.org/TR/2012/REC-xmlschema11-2-20120405/}{data types}, used for instance in \href{https://www.w3.org/TR/owl2-primer/#Datatypes}{OWL}. 

Furthermore, structured data types such as (i) date and or time, (ii) \href{https://en.wikipedia.org/wiki/Internationalized_Resource_Identifier}{IRI} including \href{https://en.wikipedia.org/wiki/Uniform_Resource_Identifier}{URI}, thus \href{https://en.wikipedia.org/wiki/URL}{URL}, (iii) \href{https://en.wikipedia.org/wiki/W3C_Geolocation_API}{geolocation}, (iv) \href{https://www.w3.org/TR/ltli}{human language tags and locale}, there is a one to one mapping between a string with specified syntax, and the data record items. The \href{https://line.gitlabpages.inria.fr/aide-group/symboling/RecordType.html#getValue}{RecordType} implementation provides an elementary mechanism of parsing based on regular expressions while existing usual middle-ware manages more sophisticated data.

New types can be defined \href{https://line.gitlabpages.inria.fr/aide-group/symboling/Type.html#declaration}{combining these ingredients, given specific parameters} or \href{https://line.gitlabpages.inria.fr/aide-group/symboling/Type.html#derivation}{deriving new types}.

Based on this design choice we consider that a data structure is the iterative combination of such scalar and compounded data types, and are going to define editing distance and projection on such data type.

\paragraph{Defining an editing distance}~\\

A resource is a forest\footnote{A set of disjoint tree data structure \url{https://en.wikipedia.org/wiki/Tree_(data_structure)}.} of semi-ordered tree \cite{ouangraoua_constrained_2009} data-structure. Furthermore, the features
of a given resource are semi-ordered (i.e., some are comparable but not necessarily all of them).

In detail, the editing distance is defined considering {\em editing operations} each with a positive cost. Such user-defined costs allowing to model the data space taking a priori application knowledge into account: we can weigh such cost to quantify the importance of a given feature.

The distance is well-defined as the sequence of editing operations with a minimal cost (see for instance \cite{abbes_modular_2018} where several alternatives are also proposed and compared), and this sequence of editing operations defined a (non-unique) editing path, with intermediate data structures at each step, making explicit which node has been added, deleted, or changed. This mechanism not only allows the definition of a distance between two inputs (as the minimal cost of editing sequences transforming one input into another), but also makes explicit which node has been added, deleted, or changed. In other words, it allows interpolating intermediate data structures between the two.

An important point is that an editing sequence is itself easily represented as a data structure, namely an ordered list of actions. It appears that this editing distance path is a geodesic as discussed in the next section. With this notion of distance and geodesic, the symbolic data space is a kind of ``non-differentiable manifold'' (in an informal sense).

Another important point is that we preserve the data structure type\footnote{For instance a list can not become a set. If two data are of different non-intersecting types, complete deletion, and insertion is the only admissible solution.}.

For compounded data type, we consider {\em editing operations} \footnote{E.g., when changing a feature value, or adding, deleting or changing a value in a list, or defining, undefining or changing a value in a record.} given an input (l+) adding, (l-) deleting or (l\#) changing a value in a list, (t+) defining, (t-) undefining or (t\#) changing a value in a tuple, each of these operations having a user-defined positive cost, related to the extended semi-distances. We thus restrict editing distances by preserving the tree filiation, computable in polynomial time\footnote{In general, considering the editing distance in a tree as a general graph, such as an ontology portion, is NP-hard, thus intractable \cite{bille_survey_2005} and sub-optimal techniques must always be considered \cite{blumenthal_new_2019}. However, considering restricted editing distances preserving the tree filiation, are computable in polynomial time \cite{ouangraoua_constrained_2009}, and we propose a variant of this approach here.} \cite{ouangraoua_constrained_2009}, which would not have been the case otherwise, or if considering the tree as a general graph or ontology portion.

At the algorithmic level, it appears that there are algorithms to effectively compute the editing distance of a given data type and make explicit the sequence of editing operations, as detailed in Appendix~\ref{data-implementation}

\paragraph{Specifying concept as data type}~\\

A region of the symbolic state space corresponds to a data type. At the modeling level this corresponds to a concept, in the sense defined before and introduced by \cite{gardenfors_conceptual_2004}, and the implementation design choices, detailed in Appendix~\ref{data-implementation}, allow that such a region is convex in the sense that along a geodesic between two values of a given, all values are of the same type. It is also rather straightforward to verify that this forms a compact, complete, and path-connected metric space\footnote{Regarding connectedness, there is an important qualitative property. Given two data structures the editing distance is bounded since to transform one to another, we always can delete all qualities of the former and insert all qualities of the latter. If the minimal editing distance equals this maximal bound, it means that both resources have nothing in common, i.e., that they are semantically disconnected, which also means that the empty data structure is on the shortest editing path. Introducing reasonable assumptions on the editing distance, e.g., that modifying a value is always less costly than deleting and inserting it, this semantic connectedness defines a partition of the resource space.}.

The proposed representation can also borrow from usual data structure representation the notion of "schema". A schema defines a set of resources that verifies some constraints, e.g., for which a feature is defined or not, or for which quality is of a given data type\footnote{This corresponds to well-established XML-Schema \url{https://en.wikipedia.org/wiki/XML_Schema_(W3C)}, or JSON-Schema \url{https://en.wikipedia.org/wiki/JSON\#Metadata_and_schema}.}. If a given data structure is compliant, its distance to the defined set is zero. Otherwise, at the programming level, human-readable messages are shared to explain what is wrong.

In our context, the notion is stronger. It not only defines a function whose value is true if and only compliant with the schema, but a {\em projector}:  A schema defines a subset of compliant data structures. If a given data structure is compliant, its distance to the defined set is zero. Otherwise, we propose to define a projector to map a non-compliant data structure onto the closest compliant data structure with respect to the editing distance, providing also the corresponding editing sequence. The precise development\footnote{For instance, in the schema each required quality has a default value, so that if missing, an insert operation can add it. If a numerical value is out of bound, the projection on the closest bound provides a straightforward solution. If the feature is of the wrong type, the only solution is to delete the value and insert a default value instead. And so on.} such a projector is beyond the scope of the present presentation but is a fundamental tool to manipulate these symbolic data structures at a geometric level. This is not always the case and that makes the difference between semantic and syntactic aspects, as explained in Appendix~\ref{data-implementation}.

To define such a projector, each type has a default value, so that if missing, an insert operation can add it\footnote{A step further, if a numerical value is out of bound, the projection on the closest bound provides a straightforward solution. If a feature is of the wrong type, the only solution is to delete the value and insert a default value instead. And so on.}. This induces the notion of a prototype of a type, as already mentioned.

Importantly, as for the schema approach, the specification of type's parameters (e.g., numerical bound and precision, or list minimal length, …) is itself a data structure, for which a vocabulary is defined, allowing to manipulate it a meta-level.

\section{Defining Scalar fields of symbolic data structures} \label{scalarfield}

\vspace*{-0.05in} \subsection{Position of the problem} \vspace*{-0.05in}

When considering problem-solving defining a trajectory from an initial state to a final goal or for reinforcement symbolic learning as developed previously, in both cases, a scalar field (i.e. a function that associates a real number to a given data structure), namely a potential in the former case and a value function in the latter case, has to be defined. Such a data structure is introduced and presented here.

Given a symbolic data structure ${\bf s} \in {\cal S}$, where ${\cal S}$ stands for a set of data structures, finite but huge and thus intractable to enumerate, a scalar field $f$ is a real-valued function:
\eqline{\begin{array}{lrcl}f:& {\cal S} &\hookrightarrow& {\cal R} \\ & {\bf s} &\rightarrow& r \\ \end{array}}
while, in our context, we define the function by setting some values:
\eqline{f({\bf s}_1) \leftarrow r_1, f({\bf s}_2) \leftarrow r_2, \cdots}
and would like to infer values for data structures in a neighborhood of these predefined values.

\vspace*{-0.05in} \subsection{Local structuration of the metric space} \vspace*{-0.05in}

We are in a metric space, thanks to the editing distance. This space is also equipped with geodesic between two data structures, thanks to the nature of the editing distance. This path between two data structures ${\bf s}_1$ and ${\bf s}_2$ is a discrete sequence built of all intermediate data structures corresponding to a truncated sequence of editing operations of minimal cost to transform a data structure to another. The key point is that for any data structure ${\bf s}_k$ on this path, by construction of the editing distance\footnote{Let us consider between ${\bf s}_1$ and ${\bf s}_2$ an intermediate data structure ${\bf s}_k$ defined by a sub-sequence of editing operations that has been used to calculate $d({\bf s}_1, {\bf s}_2)$. \\ -1- By construction, the cost $c({\bf s}_1, {\bf s}_k)$ of the sub-sequence of operation from ${\bf s}_1$ to ${\bf s}_k$ plus the cost $c({\bf s}_k, {\bf s}_2)$ of the sub-sequence of operation from ${\bf s}_k$ to ${\bf s}_2$ is equal to $d({\bf s}_1, {\bf s}_2)$. \\ -2-The cost $c({\bf s}_1, {\bf s}_k)$ can not be lower than the distance $d({\bf s}_1, {\bf s}_k)$, because $d({\bf s}_1, {\bf s}_k)$ corresponds to the cost of the lower sequence of operation from ${\bf s}_1$ to ${\bf s}_k$, by definition. \\ -3- This also the case from ${\bf s}_k$ to ${\bf s}_2$, i.e., we also have $c({\bf s}_k, {\bf s}_2) \geq d({\bf s}_k, {\bf s}_2)$.\\  
Given -1-, -2-, and -3-, and we obtain:
\eqline{\left\{\begin{array}{l}
c({\bf s}_1, {\bf s}_k) + c({\bf s}_k, {\bf s}_2) = d({\bf s}_1, {\bf s}_2) \\
c({\bf s}_1, {\bf s}_k) \geq d({\bf s}_1, {\bf s}_k) \\
c({\bf s}_k, {\bf s}_2) \geq d({\bf s}_k, {\bf s}_2) \\ \end{array}\right.
\Rightarrow d({\bf s}_1, {\bf s}_2) \geq d({\bf s}_1, {\bf s}_k) + d({\bf s}_k, {\bf s}_2),}
while from the triangular inequality we also have $d({\bf s}_1, {\bf s}_2) \leq d({\bf s}_1, {\bf s}_k) + d({\bf s}_k, {\bf s}_2)$, so that we only must conclude about the equality.\\
Another argument is that this cost $c({\bf s}_1, {\bf s}_k)$ can not be higher that the distance $d({\bf s}_1, {\bf s}_k)$, otherwise it means that there is a ``better'' sub-sequence of operation from ${\bf s}_1$ to ${\bf s}_k$, which, without changing the sub-sequence of operation from ${\bf s}_k$ to ${\bf s}_2$, will lower $d({\bf s}_1, {\bf s}_2)$, which is a contradiction. We thus must have $c({\bf s}_1, {\bf s}_k) = d({\bf s}_1, {\bf s}_k)$, with the same result for $c({\bf s}_k, {\bf s}_2)$, so that we re-derive the equality again.}:
\eqline{d({\bf s}_1, {\bf s}_k) + d({\bf s}_k, {\bf s}_2) = d({\bf s}_1, {\bf s}_2),}
which is the reason we call it a geodesic.

A key point is that the path is not unique: in our case, at the implementation level we have made the following choices:
\\ \tab - For lists, i.e., sequences, at equal cost we prefer edition to deletion, and deletion to insertion, i.e., we maintain, else reduce the list length than increase it.
\\ \tab - For sets, i.e., unordered list, we first consider the association of maximal cost before the association of lower costs.
\\ \tab - For records, i.e. labeled tuples, we consider the transformation in the item order, i.e. modifying the 1st item first. This is coherent with the fact that at the semantic level, the item order is taken into account.
\\ Such choices seem reasonable but are somehow arbitrary, and the semantic level, i.e., when meaning is given the different elements has an impact on the result. Interestingly enough, this is easily adaptable.

It is easy to verify, that for each data structure on such a geodesic, we have the minimal distance to both extremities, and the sub-geodesic segment corresponds to a geodesic of minimal length between the intermediate data structure and each extremity.

We also easily verify that our design choice of a minimal geodesic is stable, in the sense that the geodesic segment corresponds in the three cases (list, set, and record) to a geodesic that complies with the corresponding uniqueness requirement.

At a more theoretical we see here the split with respect to a usual abstract or embedded manifold: there is neither local Euclidean tangent space nor any other kind of dense continuum defined in a neighborhood of a pointy, but only geodesic paths between points. As a consequence, a gradient of a scalar field is only defined in sparse directions, without any notion of opposite direction. Though not useful for our developments, the theoretical study of such a metric structure would be of some further interest.

A more efficient, but exponentially costly design choice, would have been to generate all possible paths of minimal distance between two data structures, implementing such a mechanism is easy but rapidly intractable when the data structure size increases.

\vspace*{-0.05in} \subsection{Interpolation mechanism in a neighborhood} \vspace*{-0.05in} \label{interpolation}

Given a data structure ${\bf s}_0$ for which the scalar value has not been fixed, we need to interpolate this value given known values in a neighborhood.

Given the fact we only have a metric space, i.e. distances, we define such a neighborhood which two parameters:
\\ - Its cardinality $K$, i.e., we consider at most the $K$ closest data structure.
\\ - A maximal distance $d_{\max}$, i.e., we consider data structures whose distance is lower than $d_{\max}$.
\\ which is a very standard way of defining neighborhoods, for instance when considering operations on manifolds (see, e.g.,  \cite{burges_dimension_2010}) or graph manipulation (see, e.g. \cite{pandove_local_2017}).

Given such a neighborhood, given the available tool, we are left with the following choices:
\\ - If $K = 0$ the value is undefined.
\\ - If $K = 1$ we only can approximate the data structure scalar value by considering the closest known predefined value, i.e., the value of the data structure which is in this neighborhood singleton.
\\ - If $K > 1$, we propose to iteratively reduce the neighborhood to a singleton, i.e., until $K=1$. We consider, in the initial neighborhood, the two data structures whose relative distance is minimal and replace the two data structures with a data structure on their geodesic which is as close as possible to ${\bf s}_0$, thus reducing the neighborhood size by 1, as explained in Fig.~\ref{scalarfield-interpolation}.

\begin{figure}[htb]
\centerline{\includegraphics[width=0.5\textwidth]{./scalarfield-interpolation.png}}
\caption{As graphically represented here, ${\bf s}_1$ and ${\bf s}_2$ are replaced by the value on their geodesic as closed as possible to ${\bf s}_0$, which is then related to ${\bf s}_3$ by a geodesic, making the same choice again, which finally is related to ${\bf s}_4$, yielding to a close approximation to the unknown ${\bf s}_0$ value.} \label{scalarfield-interpolation}
\end{figure}

Given this mechanism for two data structures ${\bf s}_i$ and ${\bf s}_j$ and choosing as best location for the approximation, the data structure ${\bf s}_\bullet$ on the geodesic which distance to ${\bf s}_0$ is minimal, we can interpolate the corresponding scalar value $r_\bullet$ by a linear interpolation\footnote{This value is well defined as soon as:
\eqline{{\bf s}_i \neq {\bf s}_j \Rightarrow 0 < d({\bf s}_i, {\bf s}_j) < d({\bf s}_i, {\bf s}_\bullet) + d({\bf s}_j, {\bf s}_\bullet),} the denominator being higher than 0.}
\eqline{r_\bullet \leftarrow \frac{d({\bf s}_i, {\bf s}_\bullet) \, r_j + d({\bf s}_j, {\bf s}_\bullet) \, r_i}{d({\bf s}_i, {\bf s}_\bullet) + d({\bf s}_j, {\bf s}_\bullet)}.}.

Choosing to merge the closest data structures and replace them with the intermediate data structure which is as closed as possible to the data structure value to approximate is a reasonable choice, in this context, and yields a linear algorithm in terms of complexity\footnote{At this stage, our method is sub-optimal since we only consider one geodesic and not all possibles geodesics, and at the cost of a combinatory explosion, we could also have considered all possible geodesics between all pairs of data structures and all possible sub-geodesics between the data structures on each geodesic, to attempt to obtain a data structure as close as possible to ${\bf s}_0$, but this would not have been a tractable design choice.}.

Although we can not explicitly consider that the data structures live in an abstract manifold, i.e., a space that is locally Euclidean up to the first order, we in fact propose a method inspired by such formalism.

This method is to be compared with a straightforward linear approximation:
\eqline{r_0 \leftarrow \frac{\sum_{i=1}^K \nu(d({\bf s}_0, {\bf s}_i)) \, r_i}{\sum_{i=1}^K \nu(d({\bf s}_0, {\bf s}_i))}}
where $\nu(d)$ is some decreasing function of the distance\footnote{For instance:
$\nu(d) \deq e^{-\frac{d}{d_{\max}}} \simeq 1 - \frac{d}{d_{\max}}$.} The advantage of the former method is that it is more local, i.e., we perform linear approximation only between pair of data structures that are as close as possible to each other, while this latter straightforward formula interpolates values that are more distant.

Another interesting point is that the same iterative algorithm can be adapted to approximate a barycenter between data structures.

\vspace*{-0.05in} \subsection{Computing the barycenter of values} \vspace*{-0.05in} \label{barycenter}

Given a set or subset of weighted data structures $\{({\bf s}_1, w_1), ({\bf s}_2, w_2), \cdots \}$ we would like to approximate a data structure ${\bf s}_0$, such that\footnote{
In the Euclidean case, $d({\bf v}_0, {\bf v}_j) \deq \|{\bf v}_0 - {\bf v}_j\|$ and with $e=2$, we easily obtain for such a convex quadratic criterion by derivation of the normal equations:
\eqline{{\bf v}_0 \deq \frac{\sum_{i=1}^K w_i \, {\bf v}_i}{\sum_{i=1}^K w_i},}
obtaining the usual formula of a barycenter, or weighted centroids (see e.g. \url{https://en.wikipedia.org/wiki/Centroid}), since the linear combination of vectors ${\bf v}_i$ is defined. However, this is not the case with data structures, where we only can consider distances.}:
\eqline{{\bf s}_0 \simeq \mbox{arg min} \; l, l \deq \sum_{i=1}^K w_i \, d({\bf s}_0, {\bf s}_j)^e, e > 0, \forall i, w_i \geq 0}
which corresponds to a generalization of a barycenter, as it is required for instance in clustering algorithms, such as \href{https://en.wikipedia.org/wiki/K-means_clustering}{K-mean clustering}.

If the weights $\{\cdots w_i \cdots\}$ corresponds to the value $\{\cdots r_i \cdots\}$ we obtain the weighted centroids of the predefined set values.

If $K=1$, obviously, ${\bf s}_0 = {\bf s}_1$ is the solution since we have a minimum when $d({\bf s}_0, {\bf s}_1) = 0$.

If $K=2$, it is a reasonable choice to minimize $l = w_1 \, d({\bf s}_0, {\bf s}_1)^e + w_2 \, d({\bf s}_0, {\bf s}_2)^e$ on the geodesic between ${\bf s}_1$ and ${\bf s}_2$, because $d({\bf s}_0, {\bf s}_1) + d({\bf s}_0, {\bf s}_2) = d({\bf s}_1, {\bf s}_2)$ is minimal\footnote{Let us consider a general data structure ${\bf s}$, writing $d_1 \deq d({\bf s}, {\bf s}_1)$, $d_2 \deq d({\bf s}, {\bf s}_2)$,  $d_{12} = d({\bf s}_1, {\bf s}_2)$, thus $d_1 + d_2 \geq d_{21}$, i.e., $d_1 + d_2 = d_{12} + \epsilon, \epsilon \geq 0$, we are now left to minimize $l = w_1 \, d_1^e + w_2 \, (d_{12} + \epsilon - d_1)^e$ and it is clear that this is minimal for $\epsilon = 0$.}. This is easily performed by scanning the different data structures to find the minimal value, when not simpler\footnote{We left to the reader to verify that, if $e \leq 1$ the minimum is on one geodesic extremity, while if $e > 1$ there is a unique minimum between both extremities, while for $e = 2$, we obtain explicitly: \eqline{w_2 \, d({\bf s}_0, {\bf s}_1) = w_1 \, d({\bf s}_0, {\bf s}_2).}}.

For $K > 2$, as before we can only work on geodesics and we propose to consider the two data structures ${\bf s}_i$ and ${\bf s}_j$ with the smallest distance, calculate on their geodesic the barycenter ${\bf s}_\bullet$ with weight $w_\bullet = w_i + w_j$,
replacing the two former data structures by the latter, thus decreasing the set of data structure cardinal by 1, this being iterated until $K = 2$. This is not an optimal strategy, since we only consider a linear number of geodesics and not all possible ones, but this provides an approximate estimation, by considering only local operations.

\vspace*{-0.05in} \subsection{Computing extrapolation away from a neighborhood value} \vspace*{-0.05in} \label{extrapolation}

Another issue is to extrapolate the path from a value with respect to another one: Given a value ${\bf s}_0$, instead of finding a path towards a reference value ${\bf s}_{\sharp}$, we aim at creating a path ``away'' from this value. This is to be used to avoid an obstacle or a forbidden state when solving a problem or to explore new value when learning a behavior, as introduced in subsection~\ref{problem-solving-as-trajectory}. The more general problem of data structure exploration is drafted in Appendix~\ref{data-exploration}.

The caveat is that we do not have a priori such a mechanism\footnote{\label{extraword} Given the standard Levenshtein editing distance\footnote{\url{https://en.wikipedia.org/wiki/Levenshtein_distance}.} the editing operation have no well-defined ``inverse''. Let us consider a trivial example between {\tt mama} and {\tt mamie} easily obtained via, e.g., {\tt mama} $\rightarrow$ {\tt mame} $\rightarrow$ {\tt mamie} in two steps. Defining a string edition {\tt mama} that is ``away from'' {\tt mamie} is totally ill-defined, we could insert, delete or change any letter. Furthermore, considering the trivial example of words, there is a very little chance that when inserting, deleting, or changing any letter we draw a syntactically correct word, and even less chance to generate a semantically useful word.}. We thus have to introduce some exploration at this stage. This is not a caveat but an interesting feature, relative to finding ``creative'' solutions (in the wide sense). Furthermore, as exemplified in footnote${}^{\ref{extraword}}$, when trying to simply generate unconstrained random values around a current value, by some simple random draw, given complex symbolic data structure there is almost no chance to generate a useful or even meaningful random value.

\paragraph{Using the data type bounds}~\\ We will get around with the idea of choosing some alternative ``escape'' target ${\bf s}_i$ in order to find on the path towards these targets a data structure away from the reference. By construction, the data space is bounded as soon as sufficiently specified:

\begin{center} \begin{tabular}{|l|l|} \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/StringType.html}{string} & \parbox[u]{0.7\textwidth}{Bounded if defined by either an enumeration or by a bounded\footnote{Not all regular expressions are bounded. However, as soon as quantifiers are bounded (e.g. $s*{,max}$, in words: s $0$ to up to $max$ times) the regular expression is obviously bounded.} \href{https://en.wikipedia.org/wiki/Regular_expression}{regular expression} or a $maxLenth$ meta-value bound.}\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/ModalType.html}{modal} & \parbox[u]{0.7\textwidth}{Bounded in $[-1, 1]$.} \\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/NumericType.html}{numeric} & \parbox[u]{0.7\textwidth}{Bounded as soon as the $min$ and $max$ meta-value are defined.} \\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/EnumType.html}{enum} & \parbox[u]{0.7\textwidth}{Bounded by construction.}\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/ListType.html}{list-of-*} & \parbox[u]{0.7\textwidth}{Bounded as soon as a $maxLength$ meta-value is defined.}\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/SetType.html}{set-of-*} & \parbox[u]{0.7\textwidth}{Bounded as soon as a $maxLength$ meta-value is defined.} \\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/RecordType.html}{record} & \parbox[u]{0.7\textwidth}{Bounded as soon as the record items to take into count are explicitly enumerated.}\\ \hline
\href{https://line.gitlabpages.inria.fr/aide-group/symboling/Type.html#}{value} & \parbox[u]{0.7\textwidth}{Bounded by the fact that it is only the undefined value as explicit value.} \\ \hline
\end{tabular} \end{center}

Of course, it is important to note that given a hierarchical data structure the number of bounds increases exponentially: A list or a set with $length$ elements of a given type with $count$ bounds, $count > 1$, will obviously have $count^{length}$ possible bounds so that a list or set with $length \in \{minLength, maxLength\}$ elements will have
\eqline{\sum_{length = minLength}^{maxLength} count^{length} = \frac{count^{Maxlength-1} - count^{Minlength}}{count - 1}}
bounds. A record with $length$ items of type which bounds counts are $count_1 \cdot count_{length}$ will have
\eqline{\Pi_{i=1}^{length} count_i}
bounds. In order to consider a manageable number of bounds we easily can easily\footnote{The implementation available at \url{https://gitlab.inria.fr/line/aide-group/symboling/-/tree/master/src} is based on bounds indexing:
\\ - Only string explicit bounds enumeration is implemented at this stage, thus with obvious indexing, while numeric or modal have two bounds by construction.
\\ - Given a hierarchical type (list, set, or record) of a given element type an index is calculated modulo the number of element type bounds and indexing the position of the element in the hierarchical data structure.
\\ We thus can directly return a bound of a given by recursively decomposing this index for each element of the data structure. When randomly selecting a subset of bounds, thus a subset of indexes, we can
\\ - either shuffle all indexes and select only the first ones,
\\ - or draw indexes and check in a cache data structure that there is no repetition,
the former method being more efficient if we select a large subset of indexes, the former method being more efficient if we select a small subset.} only select a random subset of bounds.

\paragraph{Geodesic prolongation mechanism}~\\

It means that we have by construction bounds that can be used as escape values to be found on geodesics from the current value towards such bounds and away from the reference value which is to be extrapolated, as illustrated in Fig.~\ref{scalarfield-extrapolation}. Choosing the best extrapolation path is an under-determined problem. Let us discuss how to better specify it.

\begin{figure}[htb]
\centerline{\includegraphics[width=0.5\textwidth]{./scalarfield-extrapolation.png}}
\caption{Describing the extrapolation problem, see text for details.} \label{scalarfield-extrapolation}
\end{figure}

Obviously the problem is meaningful only if $d({\bf s}_{0}, {\bf s}_{\sharp}) > 0$; otherwise any value different from ${\bf s}_{\sharp}$ is a kind of extrapolation.

An interesting criterion, at the geometric level, is that geodesic from ${\bf s}_{\dagger}$ to ${\bf s}_{\sharp}$ includes ${\bf s}_0$, so that ${\bf s}_0$ is an interpolation between ${\bf s}_{\dagger}$ and ${\bf s}_{\sharp}$, justifying the term of extrapolation, as a dual notion. This means, in terms of distances:
\eqline{\nu({\bf s}_{\dagger}) \deq d({\bf s}_{\dagger}, {\bf s}_{0}) + d({\bf s}_{0}, {\bf s}_{\sharp}) - d({\bf s}_{\dagger}, {\bf s}_{\sharp}) = 0}
as discussed previously, while $\nu({\bf s}_{\dagger}) \geq 0$ in the general case, due to the distance triangular inequality. We thus have some advantage to minimize $\nu({\bf s}_{\dagger})$, i.e., find a data structure on a geodesic from ${\bf s}_0$ to ${\bf s}_i$ which minimize $\nu({\bf s}_{\dagger})$. We also can hypothesize that $\nu({\bf s}_{\dagger})$ is expected to increase along the geodesic from the current value towards a bound: this is experimentally verified at the implementation level.

The second aspect is that we want the extrapolation to be as ``away'' as possible, i.e. that $d({\bf s}_{0}, {\bf s}_{\sharp})$ must be as high as possible if it allows defining a prolongation of the ${\bf s}_0$ to ${\bf  s}_{\sharp}$ geodesic, whereas these are only valid locally. We thus have to bound $d({\bf s}_{0}, {\bf s}_{\sharp}) \leq d_{\mbox{local}}$ in order to remain in a local neighborhood.

Given this constraint and specification, we now have a well-defined algorithmic definition: {\em given all escape data structures, find on each related geodesic the data structure of maximal distance, but below $d_{\mbox{local}}$, that minimizes $\nu({\bf s}_{\dagger}) \leq 0$}.

\paragraph{Complementary specification of the extrapolation.}~\\

A step further, to attempt to better specify what ``away'' could mean, and for a data structure ${\bf s}_{\dagger}$ on the geodesic between ${\bf s}_0$ and ${\bf s}_i$ we propose two criteria,
\\ One on the distance, selecting only target ${\bf s}_{\dagger}$ with\footnote{In the Euclidean case, for any point ${\bf v}_k \deq \alpha \, {\bf v}_0 + (1 - \alpha) \, {\bf v}_{i}, \alpha \in [0, 1]$ on the geodesic between ${\bf v}_0$ and ${\bf v}_{\dagger}$ which a rectilinear segment, if $d({\bf v}_{\dagger}, {\bf v}_{\sharp}) < d({\bf v}_0, {\bf v}_{\sharp})$ we easily obtain:
\eqline{d({\bf v}_k, {\bf v}_{\sharp}) = \alpha \, d({\bf v}_0, {\bf v}_{\sharp}) + (1 - \alpha) \, d({\bf v}_{i}, {\bf v}_{\sharp}) < \alpha \, d({\bf v}_0, {\bf v}_{\sharp}) + (1 - \alpha) \, d({\bf v}_{0}, {\bf v}_{\sharp}) = d({\bf v}_0, {\bf v}_{\sharp}),}
thus we cannot obtain a extrapolation with $d({\bf v}_k, {\bf v}_{\sharp}) > d({\bf v}_{0}, {\bf v}_{\sharp})$ and we easily verify that on the reverse if $d({\bf v}_{\dagger}, {\bf v}_{\sharp}) > d({\bf v}_0, {\bf v}_{\sharp})$ any $\alpha < 1$ allows to find an extrapolation. The assumption is that for ${\bf v}_k$ close to ${\bf v}_0$ the data structure metric space is regular enough for this property to be verified.}:
\eqline{d({\bf s}_{\dagger}, {\bf s}_{\sharp}) > d({\bf s}_{\dagger}, {\bf s}_0),}
i.e., closer to the current data structure than the reference data structure.
\\ One on a generalization of the orientation, selecting only target ${\bf s}_{\dagger}$ with\footnote{From the triangle cosine law:
\eqline{d({\bf v}_{\dagger}, {\bf v}_{\sharp})^2 = d({\bf v}_{0}, {\bf v}_{\sharp})^2 + d({\bf v}_{\dagger}, {\bf v}_{0})^2 - 2 \, d({\bf v}_{0}, {\bf v}_{\sharp}) \, d({\bf v}_{\dagger}, {\bf v}_{0}) \, \cos\left(\gamma\right), \gamma \deq \widehat{\overrightarrow{{\bf v}_{0} {\bf v}_{\sharp}}, \overrightarrow{{\bf v}_{0} {\bf v}_{\dagger}}},}
and $d({\bf v}_{\dagger}, {\bf v}_{\sharp})$ is minimal, if $\gamma = \pi$, while obvious geometric properties of the triangle show that:
\eqline{d({\bf v}_{\dagger}, {\bf v}_{\sharp}) > d({\bf v}_0, {\bf v}_{\sharp}) \Leftrightarrow \gamma > \frac{\pi}{2} \Leftrightarrow \cos(\gamma) < 0}
which can be written only in terms of distance, in the case where $d({\bf v}_{0}, {\bf v}_{\sharp})$ and $d({\bf v}_{\dagger}, {\bf v}_{0})$ do not vanish, as:
\eqline{d({\bf v}_{\dagger}, {\bf v}_{0})^2 + d({\bf v}_{0}, {\bf v}_{\sharp})^2 < d({\bf v}_{\dagger}, {\bf v}_{\sharp})^2,}
while we still consider that this property is locally valid beyond the Euclidean case.}:
\eqline{d({\bf s}_{\dagger}, {\bf s}_{0})^2 + d({\bf s}_{0}, {\bf s}_{\sharp})^2 < d({\bf s}_{\dagger}, {\bf s}_{\sharp})^2,}
e.g., ${\bf s}_1$ or ${\bf s}_2$ but not ${\bf s}_3$ in the figure, thus which a locally an obtuse angle and not an acute angle.

These distance and orientation complementary constraints are useful to verify the coherence of the proposed solution or to reduce the amount of search along the geodesics.

\section{Discussion and conclusion} \label{discussion-conclusion}

\vspace*{-0.05in} \subsection{Application and formalism extension} \vspace*{-0.05in} \label{application-and-extension}

We have defined a metric space over a symbolic data structure that allows to implement generic machine-learning numeric algorithms directly on the data structure without requiring any approximate statistical embedding. Preliminary experiments have been conducted, for instance showing morphing\footnote{An image morphing demo example, using the SVG symbolic description of an image is available here:
\\ \url{https://line.gitlabpages.inria.fr/aide-group/symboling/visualmorphing/titi-toto.html} \\
and an audio morphing demo example, using the MIDI symbolic description of an image sound is available here:
\\ \url{https://line.gitlabpages.inria.fr/aide-group/symboling/musicmorphing/au-clair-de-la-lune-frere-jacques.html} \\
while the open-source implementation of SvgType and MidiType is available here:
\\\url{https://line.gitlabpages.inria.fr/aide-group/symboling}.} operations in the symbolic space \cite{bernard_symboling_2023} as illustrated in Fig.~\ref{visual-morphing-titi-toto}.

\begin{figure}[ht]
 \includegraphics[width=0.9\textwidth]{visual-morphing-titi-toto.png}
 \caption{A subset of the morphing between the ``titi´´ drawing on the left and the ``toto´´ drawing on the right: two intermediate images on the geodesic path defined by the SVG drawing representation are shown. This preliminary result shows how the symbolic data structure defining the drawing elements is changed, mainly from top to bottom, because it is the record item order. The intermediate color shows that the color space is also related to a distance in the SVG specification.}
 \label{visual-morphing-titi-toto}
\end{figure}

We also propose two illustrations\footnote{The whole data is available here:
\\ \url{https://line.gitlabpages.inria.fr/aide-group/symboling/public/trajectorydemo/type-trajectory-current.html} \\
and there:
\\ \url{https://line.gitlabpages.inria.fr/aide-group/symboling/public/qlearnerdemo/type-trajectory-current.html} \\
with also an illustration of the barycenter computation mechanism:
\\ \url{https://line.gitlabpages.inria.fr/aide-group/symboling/public/barycenterdemo/type-field-barycenter.html} \\
that shows how mechanisms normally involving numerical data are implementable with such ``symboling'' specifications. The online data may be a tiny variant of the paper figure, while data is easily modifiable.
} regarding trajectory generation in Fig.~\ref{symbolic-trajectory}, considering the simplest possible data structure to easily represent the path. As a comparison, we have experimented a Qlearning on the same task, considering the potential value as a reward as show on the web site, the aim being only to illustrate the present technical developments, in link with what was proposed in \cite{mercier_reinforcement_2021}.

\begin{figure}[ht]
 \includegraphics[width=0.9\textwidth]{symbolic-trajectory.png}
 \caption{Showing trajectory generation considering the simplest possible example. We observe the use of the Levenshtein distance for string values, our editing distances being generalizations of such editing distances. The obstacle has been set on the obstacle free geodesic between the initial state and the goal, in order to be sure to generate an obstacle avoidance. Among all possible paths since the record item order is meaningful in the specification, the first string item has transformed before the second numeric item.}
 \label{symbolic-trajectory}
\end{figure}

A more complete tiny survival digital experiment using reinforcement symbolic learning \cite{radji_early_2023}, using the principles developed here and specifying the problem via an ontology after \cite{roux_developpement_2020} has also be implemented and validated.


Let us finally discuss some applications.

\paragraph{Application to complex problem solving}~\\

We have defined problem-solving tasks at a geometric level, considering being located somewhere in a state-space, with the goal of reaching some final (unique or alternative) state, finding a way from the former to the latter, while satisfying the path constraints.

This definition is computational even for complex symbolic state space in the sense that we have developed a fully formalized problem-solving algorithm, each element being precisely defined at a symbolic level. This may be used in several computational domains, such as robotic trajectory generation and optimization, transportation theory, or operation research.

A step further,  we are interested in ill-posed problems which means that estimating the present initial state, choosing some final goal parameters, discovering the useful part of the state-space, and generating the trajectory has to be developed during the problem-solving task, and are somehow part or the task. This means that the conceptual representation has to be adapted during the task execution, i.e., completed and corrected, as preliminary experimented in \cite{radji_early_2023}.

\paragraph{Application to creative problem solving}~\\

Creative problem solving requires divergent thinking as analyzed in \cite{romero_deciphering_2023} and formalized in \cite{alexandre_modeling_2023}.In a nutshell, divergent thinking requires not only interpolating but to extrapolate new resources from existing ones. Let us illustrate these opportunities by considering three non-exclusive examples, as illustrated in Fig~\ref{search-and-analogy}:

{\em Projective divergent extrapolation:} Given a present state represented as a data structure, we may wish to extrapolate another state, only constrained by some requirement (e.g., we want to invent a "penguinemu" (a penguin morphing towards an emu)) which the only constraints that it has some of the emu's features. Thanks to the notion of schema proposed above, here used to specify the target requirements, and the notion of projector, we have an effective implemented mechanism to generate an extrapolated unprecedented resource, by projecting the prototype onto the targeted schema constraints.

{\em Sequential extrapolation:} Let us consider two resources and the editing sequence defining a path from the former to the latter, for instance, the yesterday state and the today state, whatever this means, re-applying the editing sequence on the today state allows us to extrapolate what could be the tomorrow state, under the assumption that the evolution will be the same. We could also add some randomness to explore alternatives or introduce some constraints, as in the previous example, to conform to any requirement.

{\em Reasoning by analogy:} Following the definition of analogy reasoning proposed by \cite{han_computational_2018}, e.g. reasoning of the form ``Robin is to Batman what Sancho is to Don Quixote´´ we can use the editing sequence from Robin to Batman in the source context, to re-apply it to Sancho in the target context in order to generate by analogy qualities that could apply to Don Quixote. The mapping from Robin to Sancho, i.e., from the source to the target domain, forms a commutative diagram with the source and target relations. This mechanism is iterative in \cite{han_computational_2018} and performs only at a symbolic, namely ontology, level. Here we propose to implement it at our hybrid geometric level.

\begin{figure}[ht]
 \includegraphics[width=0.9\textwidth]{search-and-analogy.png}
 \caption{A schematic representation of two kinds of generative processes. Left: Search, by extrapolation in the mirror of an interpolation between two structures. Right: Reasoning by analogy, as formalized in \cite{han_computational_2018}.}
 \label{search-and-analogy}
\end{figure}

\paragraph{Application to higher-level resources specification}~\\

These mechanisms also allow us to define not only "objects" but also higher-level resources such as rules, as schematized in Fig.~\ref{rules_with_pre+post_conditions} where the pre-condition of application corresponds to the fact the current state is compliant with respect to a given type, as defined in this contribution, while the post-condition corresponds to an editing sequence of the current state. 

\begin{figure}[htb]
  \centerline{\includegraphics[width=0.70\textwidth]{./rules_with_pre+post_conditions.png}}
  \begin{verbatim}
my-rule: {
 pre_condition: schema
 post_condition: editing-sequence
 action: ../..
}
  \end{verbatim}
  \caption{An example of higher-level specification, to formalize rule-based behavior, as discussed in e.g. \cite{alexandre_global_2021}.}
  \label{rules_with_pre+post_conditions}
\end{figure}

A step further, we also can not only define positively defined knowledge but add a property to defined uncertain, approximate knowledge, i.e., a certain belief regarding what is stated, as formalized in Appendix~\ref{modal-type}.

\vspace*{-0.05in} \subsection{On the biological plausibility of the proposed knowledge representation} \vspace*{-0.05in} \label{back-to-vsa}

Although beyond the scope of this paper, it is interesting to point out that the biologically plausible of such knowledge has been considered, in other studies. Symbolic reasoning taking place in the cortico-thamalic loops through the basal ganglia have been properly modeled using spiking neurons proposed in Vector Symbolic Approaches (VSA) approaches \cite{stewart_symbolic_2010}, while \cite{mercier_ontology_2021} has recently described how ontology representation can be encoded in such a way that reasoning entailment rules correspond to standard biological neuronal processing. Furthermore, in \cite{crawford_biologically_2016} it is shown that such Semantic Pointer Architecture scales properly to address large-scale problems, and allows one to encode data structures as defined here. 

These developments include creativity tests simulation: \cite{kajic_spiking_2017} has proposed a spiking network model to account for the Remote Associates Test simulation, storing the employed representations and reproducing human prediction, or well-posed problem solving such as the Tower of Hanoi task \cite{stewart_neural_2011}. 

In fact, such biologically plausible numerical grounding of such data structure is entirely different from the sub-symbolic numerical grounding proposed previously, because VSA approaches stand on hyper-dimensional compact (usually a hyper-sphere) space of randomly drawn vector, while basic symbolic operations are represented by abstract algebraic operators implemented as biological network simulated distributed operators. A precise development on VSA of what has been proposed here is a research project on his own, but it is clear that the basic ingredients are here.

\vspace*{-0.05in} \subsection{Conclusion} \vspace*{-0.05in} \label{conclusion}

Altogether, our design choice is to consider that any resource is defined by a simple data structure with stated, calculated, and deduced features, and mapped onto a multi-dimensional parametric space, on which we can define distance and geodesic between resources, projection onto a resource subset, and manipulation via a coordinate system. Nothing "new" here: We voluntarily sit on existing well-established formalism, thus directly benefiting from sophisticated specification paradigms and entailment algorithms. Our add-on is at the {\em design choices} level, making explicit how these different aspects of the chosen tools can interface and inter-operate, including in learning algorithms, as developed in \cite{mercier_reinforcement_2021} for a preliminary version of the present framework.

\vspace*{-0.05in} \subsection{Acknowledgments and contributions} \vspace*{-0.05in} \label{Acknowledgments}

Frédéric Alexandre is deeply acknowledged for his powerful ideas at the origin of this work, his shared expertise regarding computational neuroscience aspects of this work, and his technical advice along the work.

Margarida Romero is gratefully acknowledged for scientific discussions at the conceptual and phenomenological level regarding  creative problem-solving and human learning.

Chloé Mercier and Axel Palaude have strongly contributed to the main scientific ideas of this work, co-formulate theoretical aspects, for more than 30\% each, and have contributed to paper construction and writing.

Louis Köhler has contributed to formulating and verifying all theoretical (both at the modeling and mathematical derivation level) developments and has developed an experimental setup to make proof of concepts of these elements.

Thierry Viéville has rounded up these elements together and written the first draft of the paper.

\appendix

\section{Symbolic data implementation} \label{data-implementation} \input{dataimplementation}

\section{Data structure exploration} \label{data-exploration} \input{dataexploration}

\section{Numeric scalar data} \label{numeric-type} \input{numerictype}

\section{Numerical embedding of symbol equipped with a metric} \label{vsa-implementation} \input{vsaimplementation}
  
\section{Modal scalar data} \label{modal-type} \input{modaltype}

\section{Sub-harmonic potential} \label{subharmonic-potential} \input{subharmonic}

\section{On reinforcement Symbolic Learning} \label{qlearning} \input{qlearning}
  
\vskip 0.2in
\bibliographystyle{theapa}
\bibliography{AIDE}

\tableofcontents 

\end{document}
